@implements IAsyncDisposable
@using Microsoft.JSInterop
@using Jones.AspNetCore.Components.Forms
@inherits Jones.AspNetCore.Components.Forms.FileInputBase

<div @ref="_dropZoneElement" class="input-file-container bg-light">
    <div class="input-file-info-container">
        @if (IsProcessing)
        {
            <div class="spinner-border mb-3" role="status">
                <span class="visually-hidden">Loading...</span>
            </div>
            <span>正在处理...</span>
        }
        else
        {
            <i class="bi bi-file-earmark-arrow-up fa-2x mb-2"></i>
            <span>点击@(IsAllowDrop ? "或拖拽" : "这里")添加</span>
        }
        
        @if (Placeholder != null)
        {
            <label class="form-label" required="@(IsRequired == true ? "true" : null)">@Placeholder</label>
        }
    </div>
    <InputFile @ref="_inputFileElement" @attributes="@GetInputFileDtoAdditionalAttributes()" OnChange="OnFilesChange"/>
</div>

@code
{
    private ElementReference _dropZoneElement;
    private InputFile _inputFileElement;
        
    [Inject]
    protected IJSRuntime JSRuntime { get; set; }

    private IJSObjectReference? _fileInputInstance;
    
    protected override async Task OnAfterRenderAsync(bool firstRender)
    {
        if (firstRender)
        {
            if (IsAllowDrop)
            {
                _fileInputInstance = await JSRuntime.InvokeAsync<IJSObjectReference>("jonesBootstrap.fileInput.init", 
                    new FileInputOption(IsAllowDrop, IsAllowPaste, Accept, IsMultiple, MaxFileSize, MaximumFileCount), 
                    _dropZoneElement, _inputFileElement.Element);
            }
        }
    }

    public async ValueTask DisposeAsync()
    {
        if (_fileInputInstance != null)
        {
            await _fileInputInstance.InvokeVoidAsync("dispose");
            await _fileInputInstance.DisposeAsync();
        }
    }
}